-----------------------------------------------------------------
-- Procedure BuildTree                                         --
-----------------------------------------------------------------
-- Builds a decision tree using the ID3 method (Quinlan, 1986) --
-----------------------------------------------------------------
-- Install procedure                                           --
-----------------------------------------------------------------
-- (c) 2001 J. Darmont, ERIC, University of Lyon 2             --
-----------------------------------------------------------------
-- E-mail: jerome.darmont@univ-lyon2.fr                        --
-----------------------------------------------------------------

-----------------------------------------------------------------
-- 1) Persistent data structures                               --
-----------------------------------------------------------------

-- Type Node in Candidate list

CREATE TYPE CNode AS OBJECT( nview VARCHAR(255),		-- Node view name
			     rule VARCHAR(30),			-- Node rule
			     entrop NUMBER(10,8),		-- Node entropy
			     pop NUMBER(5));			-- Node population
/

-- List of Nodes in Candidate list

CREATE TYPE CNodeList AS TABLE OF CNode;
/

-- Candidate list (relational table)

CREATE TABLE BTCandidate( att_name VARCHAR(30) PRIMARY KEY,	-- Attribute name
			  gain NUMBER(10,8),			-- Information gain			
			  nodes CNodeList)			-- List of associated nodes
			  NESTED TABLE nodes STORE AS BTNode;

-----------------------------------------------------------------
-- 2) BuiltTree stored procedure                               --
-----------------------------------------------------------------

@BuildTree